'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withLifecycleActions = exports.INCLUDED_METHODS = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _handleAction = require('./handleAction');

var _handleAction2 = _interopRequireDefault(_handleAction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var INCLUDED_METHODS = exports.INCLUDED_METHODS = ['componentWillMount', 'componentDidMount', 'componentWillReceiveProps', 'componentWillUpdate', 'componentDidUpdate', 'componentWillUnmount'];

var withLifecycleActions = function withLifecycleActions(lifecycleActions) {

  if (process.env.NODE_ENV !== 'production') {
    console.assert((typeof lifecycleActions === 'undefined' ? 'undefined' : _typeof(lifecycleActions)) === 'object' && !Array.isArray(lifecycleActions), 'lifecycleActions must be an object.');
  }

  var lifecycleActionsKeys = Object.keys(lifecycleActions || {});

  if (process.env.NODE_ENV !== 'production') {
    var unknownKeys = lifecycleActionsKeys.filter(function (lifecycleActionKey) {
      return INCLUDED_METHODS.indexOf(lifecycleActionKey) < 0;
    });

    if (lifecycleActionsKeys.length > 0 && unknownKeys.length > 0) {
      console.warn('Unknown key(s) (' + unknownKeys.join(", ") + ') found in lifecycleActions.  Allowed keys are ' + INCLUDED_METHODS.join(", ") + '.');
    }
  }

  return function (Component) {
    var LifeCycleActionsWrapper = function (_React$Component) {
      _inherits(LifeCycleActionsWrapper, _React$Component);

      function LifeCycleActionsWrapper() {
        _classCallCheck(this, LifeCycleActionsWrapper);

        var _this = _possibleConstructorReturn(this, (LifeCycleActionsWrapper.__proto__ || Object.getPrototypeOf(LifeCycleActionsWrapper)).call(this));

        lifecycleActionsKeys.filter(function (lifecycleActionKey) {
          return INCLUDED_METHODS.indexOf(lifecycleActionKey) >= 0;
        }).forEach(function (lifecycleActionKey) {
          return _this[lifecycleActionKey] = function () {
            return (0, _handleAction2.default)(lifecycleActions[lifecycleActionKey], _this.props.dispatch, _this.getPassThroughProps());
          };
        });
        return _this;
      }

      _createClass(LifeCycleActionsWrapper, [{
        key: 'getPassThroughProps',
        value: function getPassThroughProps() {
          var _props = this.props,
              dispatch = _props.dispatch,
              passThroughProps = _objectWithoutProperties(_props, ['dispatch']);

          return passThroughProps;
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, this.getPassThroughProps());
        }
      }]);

      return LifeCycleActionsWrapper;
    }(_react2.default.Component);

    return (0, _reactRedux.connect)()(LifeCycleActionsWrapper);
  };
};
exports.withLifecycleActions = withLifecycleActions;